/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import globalAxios, { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
import { CourseBody } from '../models';
import { CourseCodeDescriptionBody } from '../models';
import { CoursesCategoryBody } from '../models';
import { GlossaryGlossaryIdBody } from '../models';
import { InlineResponse4XX } from '../models';
import { ToolGlossaryBody } from '../models';
import { ToolIdIntroTextBody } from '../models';
/**
 * CoursesApi - axios parameter creator
 * @export
 */
export const CoursesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Add a category
         * @param {CoursesCategoryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddCategory: async (body?: CoursesCategoryBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/courses/category`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add a course description
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {CourseCodeDescriptionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseAddDescription: async (courseCode: string, body?: CourseCodeDescriptionBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseAddDescription.');
            }
            const localVarPath = `/course/{course_code}/description`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add a course
         * @param {CourseBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreate: async (body?: CourseBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/course`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDelete: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseDelete.');
            }
            const localVarPath = `/course/{course_code}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteCategory: async (categoryCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'categoryCode' is not null or undefined
            if (categoryCode === null || categoryCode === undefined) {
                throw new RequiredError('categoryCode','Required parameter categoryCode was null or undefined when calling courseDeleteCategory.');
            }
            const localVarPath = `/courses/category/{category_code}`
                .replace(`{${"category_code"}}`, encodeURIComponent(String(categoryCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGet: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseGet.');
            }
            const localVarPath = `/course/{course_code}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get backup of a course
         * @param {string} courseCode unique string identifier of the course to backup.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetBackup: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseGetBackup.');
            }
            const localVarPath = `/course/{course_code}/backup`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategories: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/courses/categories`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetCategory: async (categoryCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'categoryCode' is not null or undefined
            if (categoryCode === null || categoryCode === undefined) {
                throw new RequiredError('categoryCode','Required parameter categoryCode was null or undefined when calling courseGetCategory.');
            }
            const localVarPath = `/courses/category/{category_code}`
                .replace(`{${"category_code"}}`, encodeURIComponent(String(categoryCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of courses
         * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
         * @param {number} [howmany] Number of results we want. Optional.
         * @param {number} [visibility] the visibility of the course, or all by default. Optional.
         * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
         * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetList: async (from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/courses`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            if (from !== undefined) {
                localVarQueryParameter['from'] = from;
            }

            if (howmany !== undefined) {
                localVarQueryParameter['howmany'] = howmany;
            }

            if (visibility !== undefined) {
                localVarQueryParameter['visibility'] = visibility;
            }

            if (startwith !== undefined) {
                localVarQueryParameter['startwith'] = startwith;
            }

            if (alsoSearchCode !== undefined) {
                localVarQueryParameter['alsoSearchCode'] = alsoSearchCode;
            }

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of resources in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetResources: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseGetResources.');
            }
            const localVarPath = `/course/{course_code}/resources`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Adds a new term to the course glossary tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {ToolGlossaryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddGlossaryTerm: async (courseCode: string, body?: ToolGlossaryBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling toolAddGlossaryTerm.');
            }
            const localVarPath = `/course/{course_code}/tool/glossary`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Adds an introduction text to specified tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {string} toolId The id of the tool.
         * @param {ToolIdIntroTextBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolAddIntroText: async (courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling toolAddIntroText.');
            }
            // verify required parameter 'toolId' is not null or undefined
            if (toolId === null || toolId === undefined) {
                throw new RequiredError('toolId','Required parameter toolId was null or undefined when calling toolAddIntroText.');
            }
            const localVarPath = `/course/{course_code}/tool/{tool_id}/intro_text`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"tool_id"}}`, encodeURIComponent(String(toolId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Deletes a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolDeleteGlossaryTerm: async (courseCode: string, glossaryId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling toolDeleteGlossaryTerm.');
            }
            // verify required parameter 'glossaryId' is not null or undefined
            if (glossaryId === null || glossaryId === undefined) {
                throw new RequiredError('glossaryId','Required parameter glossaryId was null or undefined when calling toolDeleteGlossaryTerm.');
            }
            const localVarPath = `/course/{course_code}/tool/glossary/{glossary_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"glossary_id"}}`, encodeURIComponent(String(glossaryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Edits a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {GlossaryGlossaryIdBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolEditGlossaryTerm: async (courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling toolEditGlossaryTerm.');
            }
            // verify required parameter 'glossaryId' is not null or undefined
            if (glossaryId === null || glossaryId === undefined) {
                throw new RequiredError('glossaryId','Required parameter glossaryId was null or undefined when calling toolEditGlossaryTerm.');
            }
            const localVarPath = `/course/{course_code}/tool/glossary/{glossary_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"glossary_id"}}`, encodeURIComponent(String(glossaryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of terms from course glossary
         * @param {string} courseCode unique string identifier of the course.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        toolGetGlossaryTerms: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling toolGetGlossaryTerms.');
            }
            const localVarPath = `/course/{course_code}/tool/glossary`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * CoursesApi - functional programming interface
 * @export
 */
export const CoursesApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Add a category
         * @param {CoursesCategoryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseAddCategory(body?: CoursesCategoryBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseAddCategory(body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Add a course description
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {CourseCodeDescriptionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseAddDescription(courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseAddDescription(courseCode, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Add a course
         * @param {CourseBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseCreate(body?: CourseBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseCreate(body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDelete(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseDelete(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDeleteCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseDeleteCategory(categoryCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGet(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseGet(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get backup of a course
         * @param {string} courseCode unique string identifier of the course to backup.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetBackup(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseGetBackup(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetCategories(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseGetCategories(options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseGetCategory(categoryCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of courses
         * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
         * @param {number} [howmany] Number of results we want. Optional.
         * @param {number} [visibility] the visibility of the course, or all by default. Optional.
         * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
         * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetList(from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseGetList(from, howmany, visibility, startwith, alsoSearchCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of resources in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetResources(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).courseGetResources(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Adds a new term to the course glossary tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {ToolGlossaryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolAddGlossaryTerm(courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).toolAddGlossaryTerm(courseCode, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Adds an introduction text to specified tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {string} toolId The id of the tool.
         * @param {ToolIdIntroTextBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolAddIntroText(courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).toolAddIntroText(courseCode, toolId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Deletes a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolDeleteGlossaryTerm(courseCode: string, glossaryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).toolDeleteGlossaryTerm(courseCode, glossaryId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Edits a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {GlossaryGlossaryIdBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolEditGlossaryTerm(courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).toolEditGlossaryTerm(courseCode, glossaryId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of terms from course glossary
         * @param {string} courseCode unique string identifier of the course.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolGetGlossaryTerms(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await CoursesApiAxiosParamCreator(configuration).toolGetGlossaryTerms(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * CoursesApi - factory interface
 * @export
 */
export const CoursesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Add a category
         * @param {CoursesCategoryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseAddCategory(body?: CoursesCategoryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseAddCategory(body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add a course description
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {CourseCodeDescriptionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseAddDescription(courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseAddDescription(courseCode, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add a course
         * @param {CourseBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseCreate(body?: CourseBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseCreate(body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDelete(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseDelete(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDeleteCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseDeleteCategory(categoryCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get course by course code
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGet(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseGet(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get backup of a course
         * @param {string} courseCode unique string identifier of the course to backup.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetBackup(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseGetBackup(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetCategories(options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseGetCategories(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get category by category code
         * @param {string} categoryCode unique string identifier of the category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseGetCategory(categoryCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of courses
         * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
         * @param {number} [howmany] Number of results we want. Optional.
         * @param {number} [visibility] the visibility of the course, or all by default. Optional.
         * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
         * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetList(from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseGetList(from, howmany, visibility, startwith, alsoSearchCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of resources in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetResources(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).courseGetResources(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Adds a new term to the course glossary tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {ToolGlossaryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolAddGlossaryTerm(courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).toolAddGlossaryTerm(courseCode, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Adds an introduction text to specified tool
         * @param {string} courseCode unique string identifier of the course.
         * @param {string} toolId The id of the tool.
         * @param {ToolIdIntroTextBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolAddIntroText(courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).toolAddIntroText(courseCode, toolId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Deletes a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolDeleteGlossaryTerm(courseCode: string, glossaryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).toolDeleteGlossaryTerm(courseCode, glossaryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Edits a glossary term by id.
         * @param {string} courseCode unique string identifier of the course.
         * @param {number} glossaryId unique integer identifier of the glossary term.
         * @param {GlossaryGlossaryIdBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolEditGlossaryTerm(courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).toolEditGlossaryTerm(courseCode, glossaryId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of terms from course glossary
         * @param {string} courseCode unique string identifier of the course.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async toolGetGlossaryTerms(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return CoursesApiFp(configuration).toolGetGlossaryTerms(courseCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * CoursesApi - object-oriented interface
 * @export
 * @class CoursesApi
 * @extends {BaseAPI}
 */
export class CoursesApi extends BaseAPI {
    /**
     * 
     * @summary Add a category
     * @param {CoursesCategoryBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseAddCategory(body?: CoursesCategoryBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseAddCategory(body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Add a course description
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {CourseCodeDescriptionBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseAddDescription(courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseAddDescription(courseCode, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Add a course
     * @param {CourseBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseCreate(body?: CourseBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseCreate(body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseDelete(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseDelete(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseDeleteCategory(categoryCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseDeleteCategory(categoryCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseGet(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseGet(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get backup of a course
     * @param {string} courseCode unique string identifier of the course to backup.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseGetBackup(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseGetBackup(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseGetCategories(options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseGetCategories(options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseGetCategory(categoryCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseGetCategory(categoryCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of courses
     * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
     * @param {number} [howmany] Number of results we want. Optional.
     * @param {number} [visibility] the visibility of the course, or all by default. Optional.
     * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
     * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseGetList(from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseGetList(from, howmany, visibility, startwith, alsoSearchCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of resources in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async courseGetResources(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).courseGetResources(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Adds a new term to the course glossary tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {ToolGlossaryBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async toolAddGlossaryTerm(courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).toolAddGlossaryTerm(courseCode, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Adds an introduction text to specified tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {string} toolId The id of the tool.
     * @param {ToolIdIntroTextBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async toolAddIntroText(courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).toolAddIntroText(courseCode, toolId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Deletes a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async toolDeleteGlossaryTerm(courseCode: string, glossaryId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).toolDeleteGlossaryTerm(courseCode, glossaryId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Edits a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {GlossaryGlossaryIdBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async toolEditGlossaryTerm(courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).toolEditGlossaryTerm(courseCode, glossaryId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of terms from course glossary
     * @param {string} courseCode unique string identifier of the course.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    public async toolGetGlossaryTerms(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return CoursesApiFp(this.configuration).toolGetGlossaryTerms(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
}
