/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import globalAxios, { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
import { InlineResponse4XX } from '../models';
import { LearningpathIdDocumentBody } from '../models';
/**
 * DocumentsApi - axios parameter creator
 * @export
 */
export const DocumentsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Soft delete a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteDocument: async (courseCode: string, documentId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseDeleteDocument.');
            }
            // verify required parameter 'documentId' is not null or undefined
            if (documentId === null || documentId === undefined) {
                throw new RequiredError('documentId','Required parameter documentId was null or undefined when calling courseDeleteDocument.');
            }
            const localVarPath = `/course/{course_code}/document/{document_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"document_id"}}`, encodeURIComponent(String(documentId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocument: async (courseCode: string, documentId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseGetDocument.');
            }
            // verify required parameter 'documentId' is not null or undefined
            if (documentId === null || documentId === undefined) {
                throw new RequiredError('documentId','Required parameter documentId was null or undefined when calling courseGetDocument.');
            }
            const localVarPath = `/course/{course_code}/document/{document_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"document_id"}}`, encodeURIComponent(String(documentId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of documents in course
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetDocuments: async (courseCode: string, path?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseGetDocuments.');
            }
            const localVarPath = `/course/{course_code}/documents`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            if (path !== undefined) {
                localVarQueryParameter['path'] = path;
            }

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Upload a document into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [file] 
         * @param {string} [path] 
         * @param {string} [title] 
         * @param {string} [comment] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadDocumentForm: async (courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseUploadDocumentForm.');
            }
            const localVarPath = `/course/{course_code}/document`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new FormData();

            // authentication bearerAuth required


            if (file !== undefined) { 
                localVarFormParams.append('file', file as any);
            }

            if (path !== undefined) { 
                localVarFormParams.append('path', path as any);
            }

            if (title !== undefined) { 
                localVarFormParams.append('title', title as any);
            }

            if (comment !== undefined) { 
                localVarFormParams.append('comment', comment as any);
            }

            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Upload an image into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [imageUpload] 
         * @param {string} [title] 
         * @param {string} [comment] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseUploadImageForm: async (courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseUploadImageForm.');
            }
            const localVarPath = `/course/{course_code}/documents/image`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new FormData();

            // authentication bearerAuth required


            if (imageUpload !== undefined) { 
                localVarFormParams.append('imageUpload', imageUpload as any);
            }

            if (title !== undefined) { 
                localVarFormParams.append('title', title as any);
            }

            if (comment !== undefined) { 
                localVarFormParams.append('comment', comment as any);
            }

            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a document in a learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdDocumentBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateDocument: async (courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpCreateDocument.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpCreateDocument.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/document`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of documents in learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetDocuments: async (courseCode: string, learningpathId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGetDocuments.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpGetDocuments.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/documents`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * DocumentsApi - functional programming interface
 * @export
 */
export const DocumentsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Soft delete a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDeleteDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).courseDeleteDocument(courseCode, documentId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).courseGetDocument(courseCode, documentId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of documents in course
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetDocuments(courseCode: string, path?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).courseGetDocuments(courseCode, path, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Upload a document into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [file] 
         * @param {string} [path] 
         * @param {string} [title] 
         * @param {string} [comment] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseUploadDocumentForm(courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).courseUploadDocumentForm(courseCode, file, path, title, comment, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Upload an image into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [imageUpload] 
         * @param {string} [title] 
         * @param {string} [comment] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseUploadImageForm(courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).courseUploadImageForm(courseCode, imageUpload, title, comment, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Create a document in a learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdDocumentBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateDocument(courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).lpCreateDocument(courseCode, learningpathId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of documents in learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetDocuments(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await DocumentsApiAxiosParamCreator(configuration).lpGetDocuments(courseCode, learningpathId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * DocumentsApi - factory interface
 * @export
 */
export const DocumentsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Soft delete a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDeleteDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).courseDeleteDocument(courseCode, documentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a document from a course.
         * @param {string} courseCode unique string identifier of the course in which the documend is located.
         * @param {string} documentId unique int identifier of the requested document.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).courseGetDocument(courseCode, documentId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of documents in course
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetDocuments(courseCode: string, path?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).courseGetDocuments(courseCode, path, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Upload a document into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [file] 
         * @param {string} [path] 
         * @param {string} [title] 
         * @param {string} [comment] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseUploadDocumentForm(courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).courseUploadDocumentForm(courseCode, file, path, title, comment, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Upload an image into a course
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {Blob} [imageUpload] 
         * @param {string} [title] 
         * @param {string} [comment] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseUploadImageForm(courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).courseUploadImageForm(courseCode, imageUpload, title, comment, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a document in a learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdDocumentBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateDocument(courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).lpCreateDocument(courseCode, learningpathId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of documents in learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
         * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetDocuments(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return DocumentsApiFp(configuration).lpGetDocuments(courseCode, learningpathId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * DocumentsApi - object-oriented interface
 * @export
 * @class DocumentsApi
 * @extends {BaseAPI}
 */
export class DocumentsApi extends BaseAPI {
    /**
     * 
     * @summary Soft delete a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async courseDeleteDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).courseDeleteDocument(courseCode, documentId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async courseGetDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).courseGetDocument(courseCode, documentId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of documents in course
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async courseGetDocuments(courseCode: string, path?: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).courseGetDocuments(courseCode, path, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Upload a document into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [file] 
     * @param {string} [path] 
     * @param {string} [title] 
     * @param {string} [comment] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async courseUploadDocumentForm(courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).courseUploadDocumentForm(courseCode, file, path, title, comment, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Upload an image into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [imageUpload] 
     * @param {string} [title] 
     * @param {string} [comment] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async courseUploadImageForm(courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).courseUploadImageForm(courseCode, imageUpload, title, comment, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Create a document in a learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdDocumentBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async lpCreateDocument(courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).lpCreateDocument(courseCode, learningpathId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of documents in learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    public async lpGetDocuments(courseCode: string, learningpathId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return DocumentsApiFp(this.configuration).lpGetDocuments(courseCode, learningpathId, options).then((request) => request(this.axios, this.basePath));
    }
}
