/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import globalAxios, { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
import { CourseCodeLearningpathBody } from '../models';
import { InlineResponse4XX } from '../models';
import { LearningpathIdItemBody } from '../models';
import { LearningpathIdSectionBody } from '../models';
import { LearningpathsCategoryBody } from '../models';
import { LpItemIdAudioBody1 } from '../models';
/**
 * LearningPathsApi - axios parameter creator
 * @export
 */
export const LearningPathsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
         * @param {CourseCodeLearningpathBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreate: async (courseCode: string, body?: CourseCodeLearningpathBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpCreate.');
            }
            const localVarPath = `/course/{course_code}/learningpath`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a learning path category in a course
         * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
         * @param {LearningpathsCategoryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateCategory: async (courseCode: string, body?: LearningpathsCategoryBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpCreateCategory.');
            }
            const localVarPath = `/course/{course_code}/learningpaths/category`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Creates an item in a learning path from a resource
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdItemBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateItem: async (courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpCreateItem.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpCreateItem.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/item`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add section to learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdSectionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpCreateSection: async (courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpCreateSection.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpCreateSection.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/section`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDelete: async (courseCode: string, learningpathId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpDelete.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpDelete.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteCategory: async (courseCode: string, categoryId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpDeleteCategory.');
            }
            // verify required parameter 'categoryId' is not null or undefined
            if (categoryId === null || categoryId === undefined) {
                throw new RequiredError('categoryId','Required parameter categoryId was null or undefined when calling lpDeleteCategory.');
            }
            const localVarPath = `/course/{course_code}/learningpaths/category/{category_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"category_id"}}`, encodeURIComponent(String(categoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpDeleteSection: async (courseCode: string, learningpathId: number, sectionId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpDeleteSection.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpDeleteSection.');
            }
            // verify required parameter 'sectionId' is not null or undefined
            if (sectionId === null || sectionId === undefined) {
                throw new RequiredError('sectionId','Required parameter sectionId was null or undefined when calling lpDeleteSection.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/section/{section_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)))
                .replace(`{${"section_id"}}`, encodeURIComponent(String(sectionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get learningpath as scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {number} learningpathId unique int identifier of the learning path.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpExportScorm: async (courseCode: string, learningpathId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpExportScorm.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpExportScorm.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/scorm`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a learning path from a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGet: async (courseCode: string, learningpathId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGet.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpGet.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List learning paths categories from course
         * @param {string} courseCode the id of the course from which to list the learning path categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategories: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGetCategories.');
            }
            const localVarPath = `/course/{course_code}/learningpaths/categories`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetCategory: async (courseCode: string, categoryId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGetCategory.');
            }
            // verify required parameter 'categoryId' is not null or undefined
            if (categoryId === null || categoryId === undefined) {
                throw new RequiredError('categoryId','Required parameter categoryId was null or undefined when calling lpGetCategory.');
            }
            const localVarPath = `/course/{course_code}/learningpaths/category/{category_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"category_id"}}`, encodeURIComponent(String(categoryId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary List items (including sections) from course's learning path
         * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
         * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetItems: async (courseCode: string, learningpathId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGetItems.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpGetItems.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/items`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of learning paths from course
         * @param {string} courseCode the id of the course from which to list the learning paths
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetList: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGetList.');
            }
            const localVarPath = `/course/{course_code}/learningpaths`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpGetSection: async (courseCode: string, learningpathId: number, sectionId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpGetSection.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpGetSection.');
            }
            // verify required parameter 'sectionId' is not null or undefined
            if (sectionId === null || sectionId === undefined) {
                throw new RequiredError('sectionId','Required parameter sectionId was null or undefined when calling lpGetSection.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/section/{section_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)))
                .replace(`{${"section_id"}}`, encodeURIComponent(String(sectionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create learningpath from scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {Blob} [scormUpload] 
         * @param {number} [useMaxScore] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpImportScormForm: async (courseCode: string, scormUpload?: Blob, useMaxScore?: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpImportScormForm.');
            }
            const localVarPath = `/course/{course_code}/learningpath/scorm`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new FormData();

            // authentication bearerAuth required


            if (scormUpload !== undefined) { 
                localVarFormParams.append('scormUpload', scormUpload as any);
            }

            if (useMaxScore !== undefined) { 
                localVarFormParams.append('use_max_score', useMaxScore as any);
            }

            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add existing audio document to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {LpItemIdAudioBody1} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemAddExistingAudio: async (courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpItemAddExistingAudio.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpItemAddExistingAudio.');
            }
            // verify required parameter 'lpItemId' is not null or undefined
            if (lpItemId === null || lpItemId === undefined) {
                throw new RequiredError('lpItemId','Required parameter lpItemId was null or undefined when calling lpItemAddExistingAudio.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/item/{lp_item_id}/audio`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)))
                .replace(`{${"lp_item_id"}}`, encodeURIComponent(String(lpItemId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add audio to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {Blob} [file] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        lpItemUploadAudioForm: async (courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling lpItemUploadAudioForm.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling lpItemUploadAudioForm.');
            }
            // verify required parameter 'lpItemId' is not null or undefined
            if (lpItemId === null || lpItemId === undefined) {
                throw new RequiredError('lpItemId','Required parameter lpItemId was null or undefined when calling lpItemUploadAudioForm.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/item/{lp_item_id}/audio`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)))
                .replace(`{${"lp_item_id"}}`, encodeURIComponent(String(lpItemId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new FormData();

            // authentication bearerAuth required


            if (file !== undefined) { 
                localVarFormParams.append('file', file as any);
            }

            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * LearningPathsApi - functional programming interface
 * @export
 */
export const LearningPathsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Create a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
         * @param {CourseCodeLearningpathBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreate(courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpCreate(courseCode, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Create a learning path category in a course
         * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
         * @param {LearningpathsCategoryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateCategory(courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpCreateCategory(courseCode, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Creates an item in a learning path from a resource
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdItemBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateItem(courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpCreateItem(courseCode, learningpathId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Add section to learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdSectionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateSection(courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpCreateSection(courseCode, learningpathId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpDelete(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpDelete(courseCode, learningpathId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpDeleteCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpDeleteCategory(courseCode, categoryId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpDeleteSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpDeleteSection(courseCode, learningpathId, sectionId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get learningpath as scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {number} learningpathId unique int identifier of the learning path.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpExportScorm(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpExportScorm(courseCode, learningpathId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a learning path from a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGet(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpGet(courseCode, learningpathId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary List learning paths categories from course
         * @param {string} courseCode the id of the course from which to list the learning path categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetCategories(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpGetCategories(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpGetCategory(courseCode, categoryId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary List items (including sections) from course's learning path
         * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
         * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetItems(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpGetItems(courseCode, learningpathId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of learning paths from course
         * @param {string} courseCode the id of the course from which to list the learning paths
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetList(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpGetList(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpGetSection(courseCode, learningpathId, sectionId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Create learningpath from scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {Blob} [scormUpload] 
         * @param {number} [useMaxScore] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpImportScormForm(courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpImportScormForm(courseCode, scormUpload, useMaxScore, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Add existing audio document to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {LpItemIdAudioBody1} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpItemAddExistingAudio(courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpItemAddExistingAudio(courseCode, learningpathId, lpItemId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Add audio to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {Blob} [file] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpItemUploadAudioForm(courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await LearningPathsApiAxiosParamCreator(configuration).lpItemUploadAudioForm(courseCode, learningpathId, lpItemId, file, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * LearningPathsApi - factory interface
 * @export
 */
export const LearningPathsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Create a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
         * @param {CourseCodeLearningpathBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreate(courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpCreate(courseCode, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a learning path category in a course
         * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
         * @param {LearningpathsCategoryBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateCategory(courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpCreateCategory(courseCode, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Creates an item in a learning path from a resource
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdItemBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateItem(courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpCreateItem(courseCode, learningpathId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add section to learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
         * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
         * @param {LearningpathIdSectionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpCreateSection(courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpCreateSection(courseCode, learningpathId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a learning path in a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpDelete(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpDelete(courseCode, learningpathId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpDeleteCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpDeleteCategory(courseCode, categoryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpDeleteSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpDeleteSection(courseCode, learningpathId, sectionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get learningpath as scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {number} learningpathId unique int identifier of the learning path.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpExportScorm(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpExportScorm(courseCode, learningpathId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a learning path from a course
         * @param {string} courseCode unique string identifier of the course in which the learning is located.
         * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGet(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpGet(courseCode, learningpathId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List learning paths categories from course
         * @param {string} courseCode the id of the course from which to list the learning path categories
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetCategories(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpGetCategories(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a learning path category from a course
         * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
         * @param {number} categoryId unique int identifier of the requested learning path category.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpGetCategory(courseCode, categoryId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary List items (including sections) from course's learning path
         * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
         * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetItems(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpGetItems(courseCode, learningpathId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of learning paths from course
         * @param {string} courseCode the id of the course from which to list the learning paths
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetList(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpGetList(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get section from learning path
         * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
         * @param {number} learningpathId unique int identifier of the learning path in which the section is located
         * @param {number} sectionId unique int identifier of the requested section.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpGetSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpGetSection(courseCode, learningpathId, sectionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create learningpath from scorm package
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {Blob} [scormUpload] 
         * @param {number} [useMaxScore] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpImportScormForm(courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpImportScormForm(courseCode, scormUpload, useMaxScore, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add existing audio document to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {LpItemIdAudioBody1} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpItemAddExistingAudio(courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpItemAddExistingAudio(courseCode, learningpathId, lpItemId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add audio to learning path item
         * @param {string} courseCode unique string identifier of the course in which the learning path is located.
         * @param {string} learningpathId unique string identifier of the learning path.
         * @param {string} lpItemId unique string identifier of the learning path item.
         * @param {Blob} [file] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async lpItemUploadAudioForm(courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return LearningPathsApiFp(configuration).lpItemUploadAudioForm(courseCode, learningpathId, lpItemId, file, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * LearningPathsApi - object-oriented interface
 * @export
 * @class LearningPathsApi
 * @extends {BaseAPI}
 */
export class LearningPathsApi extends BaseAPI {
    /**
     * 
     * @summary Create a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
     * @param {CourseCodeLearningpathBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpCreate(courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpCreate(courseCode, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Create a learning path category in a course
     * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
     * @param {LearningpathsCategoryBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpCreateCategory(courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpCreateCategory(courseCode, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Creates an item in a learning path from a resource
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdItemBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpCreateItem(courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpCreateItem(courseCode, learningpathId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Add section to learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdSectionBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpCreateSection(courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpCreateSection(courseCode, learningpathId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpDelete(courseCode: string, learningpathId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpDelete(courseCode, learningpathId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpDeleteCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpDeleteCategory(courseCode, categoryId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpDeleteSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpDeleteSection(courseCode, learningpathId, sectionId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get learningpath as scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {number} learningpathId unique int identifier of the learning path.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpExportScorm(courseCode: string, learningpathId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpExportScorm(courseCode, learningpathId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get a learning path from a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpGet(courseCode: string, learningpathId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpGet(courseCode, learningpathId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary List learning paths categories from course
     * @param {string} courseCode the id of the course from which to list the learning path categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpGetCategories(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpGetCategories(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpGetCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpGetCategory(courseCode, categoryId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary List items (including sections) from course's learning path
     * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
     * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpGetItems(courseCode: string, learningpathId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpGetItems(courseCode, learningpathId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of learning paths from course
     * @param {string} courseCode the id of the course from which to list the learning paths
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpGetList(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpGetList(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpGetSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpGetSection(courseCode, learningpathId, sectionId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Create learningpath from scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {Blob} [scormUpload] 
     * @param {number} [useMaxScore] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpImportScormForm(courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpImportScormForm(courseCode, scormUpload, useMaxScore, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Add existing audio document to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {LpItemIdAudioBody1} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpItemAddExistingAudio(courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpItemAddExistingAudio(courseCode, learningpathId, lpItemId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Add audio to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {Blob} [file] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    public async lpItemUploadAudioForm(courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return LearningPathsApiFp(this.configuration).lpItemUploadAudioForm(courseCode, learningpathId, lpItemId, file, options).then((request) => request(this.axios, this.basePath));
    }
}
