/* tslint:disable */
/* eslint-disable */
/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import globalAxios, { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
import { CourseCodeQuestionBody } from '../models';
import { CourseCodeTestBody } from '../models';
import { InlineResponse4XX } from '../models';
import { LearningpathIdTestBody } from '../models';
import { QuestionIdAnswerBody } from '../models';
import { TestIdQuestionBody } from '../models';
/**
 * TestsApi - axios parameter creator
 * @export
 */
export const TestsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Creates a question in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeQuestionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseCreateQuestion: async (courseCode: string, body?: CourseCodeQuestionBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseCreateQuestion.');
            }
            const localVarPath = `/course/{course_code}/question`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a question and remove it from all tests.
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseDeleteQuestion: async (courseCode: string, questionId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseDeleteQuestion.');
            }
            // verify required parameter 'questionId' is not null or undefined
            if (questionId === null || questionId === undefined) {
                throw new RequiredError('questionId','Required parameter questionId was null or undefined when calling courseDeleteQuestion.');
            }
            const localVarPath = `/course/{course_code}/question/{question_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"question_id"}}`, encodeURIComponent(String(questionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a question from a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        courseGetQuestion: async (courseCode: string, questionId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling courseGetQuestion.');
            }
            // verify required parameter 'questionId' is not null or undefined
            if (questionId === null || questionId === undefined) {
                throw new RequiredError('questionId','Required parameter questionId was null or undefined when calling courseGetQuestion.');
            }
            const localVarPath = `/course/{course_code}/question/{question_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"question_id"}}`, encodeURIComponent(String(questionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
         * @param {string} courseCode unique string identifier of the course in which the answer will be located.
         * @param {string} testId unique int identifier of the test the answer will belong to.
         * @param {string} questionId unique int identifier of the question in which the answer will be added.
         * @param {QuestionIdAnswerBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionCreateAnswer: async (courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling questionCreateAnswer.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling questionCreateAnswer.');
            }
            // verify required parameter 'questionId' is not null or undefined
            if (questionId === null || questionId === undefined) {
                throw new RequiredError('questionId','Required parameter questionId was null or undefined when calling questionCreateAnswer.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}/question/{question_id}/answer`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)))
                .replace(`{${"question_id"}}`, encodeURIComponent(String(questionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get answers from a question
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {string} testId unique integer identifier of the test.
         * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionGetAnswer: async (courseCode: string, testId: string, questionId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling questionGetAnswer.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling questionGetAnswer.');
            }
            // verify required parameter 'questionId' is not null or undefined
            if (questionId === null || questionId === undefined) {
                throw new RequiredError('questionId','Required parameter questionId was null or undefined when calling questionGetAnswer.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}/question/{question_id}/answers`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)))
                .replace(`{${"question_id"}}`, encodeURIComponent(String(questionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Upload an image into a question
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} questionId unique string identifier of the parent question.
         * @param {Blob} [imageUpload] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        questionUploadImageForm: async (courseCode: string, questionId: number, imageUpload?: Blob, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling questionUploadImageForm.');
            }
            // verify required parameter 'questionId' is not null or undefined
            if (questionId === null || questionId === undefined) {
                throw new RequiredError('questionId','Required parameter questionId was null or undefined when calling questionUploadImageForm.');
            }
            const localVarPath = `/course/{course_code}/question/{question_id}/image`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"question_id"}}`, encodeURIComponent(String(questionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;
            const localVarFormParams = new FormData();

            // authentication bearerAuth required


            if (imageUpload !== undefined) { 
                localVarFormParams.append('imageUpload', imageUpload as any);
            }

            localVarHeaderParameter['Content-Type'] = 'multipart/form-data';
            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = localVarFormParams;

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a test in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeTestBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreate: async (courseCode: string, body?: CourseCodeTestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testCreate.');
            }
            const localVarPath = `/course/{course_code}/test`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a test in a learningpath
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
         * @param {LearningpathIdTestBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateInLp: async (courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testCreateInLp.');
            }
            // verify required parameter 'learningpathId' is not null or undefined
            if (learningpathId === null || learningpathId === undefined) {
                throw new RequiredError('learningpathId','Required parameter learningpathId was null or undefined when calling testCreateInLp.');
            }
            const localVarPath = `/course/{course_code}/learningpath/{learningpath_id}/test`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"learningpath_id"}}`, encodeURIComponent(String(learningpathId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a question in a test
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} testId unique int identifier of the test in which the question will be added.
         * @param {TestIdQuestionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testCreateQuestion: async (courseCode: string, testId: number, body?: TestIdQuestionBody, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testCreateQuestion.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling testCreateQuestion.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}/question`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            localVarHeaderParameter['Content-Type'] = 'application/json';

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            const needsSerialization = (typeof body !== "string") || localVarRequestOptions.headers['Content-Type'] === 'application/json';
            localVarRequestOptions.data =  needsSerialization ? JSON.stringify(body !== undefined ? body : {}) : (body || "");

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testDelete: async (courseCode: string, testId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testDelete.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling testDelete.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGet: async (courseCode: string, testId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testGet.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling testGet.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get list of tests in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetList: async (courseCode: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testGetList.');
            }
            const localVarPath = `/course/{course_code}/tests`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get questions from a test
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {number} testId unique integer identifier of the test you wish to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testGetQuestions: async (courseCode: string, testId: number, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testGetQuestions.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling testGetQuestions.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}/questions`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Remove a question from a test.
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} testId unique integer identifier of the parent test.
         * @param {string} questionId unique integer identifier of the parent question.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        testRemoveQuestion: async (courseCode: string, testId: number, questionId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'courseCode' is not null or undefined
            if (courseCode === null || courseCode === undefined) {
                throw new RequiredError('courseCode','Required parameter courseCode was null or undefined when calling testRemoveQuestion.');
            }
            // verify required parameter 'testId' is not null or undefined
            if (testId === null || testId === undefined) {
                throw new RequiredError('testId','Required parameter testId was null or undefined when calling testRemoveQuestion.');
            }
            // verify required parameter 'questionId' is not null or undefined
            if (questionId === null || questionId === undefined) {
                throw new RequiredError('questionId','Required parameter questionId was null or undefined when calling testRemoveQuestion.');
            }
            const localVarPath = `/course/{course_code}/test/{test_id}/question/{question_id}`
                .replace(`{${"course_code"}}`, encodeURIComponent(String(courseCode)))
                .replace(`{${"test_id"}}`, encodeURIComponent(String(testId)))
                .replace(`{${"question_id"}}`, encodeURIComponent(String(questionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, 'https://example.com');
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }
            const localVarRequestOptions :AxiosRequestConfig = { method: 'PATCH', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication bearerAuth required

            const query = new URLSearchParams(localVarUrlObj.search);
            for (const key in localVarQueryParameter) {
                query.set(key, localVarQueryParameter[key]);
            }
            for (const key in options.params) {
                query.set(key, options.params[key]);
            }
            localVarUrlObj.search = (new URLSearchParams(query)).toString();
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: localVarUrlObj.pathname + localVarUrlObj.search + localVarUrlObj.hash,
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * TestsApi - functional programming interface
 * @export
 */
export const TestsApiFp = function(configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Creates a question in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeQuestionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseCreateQuestion(courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).courseCreateQuestion(courseCode, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a question and remove it from all tests.
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDeleteQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).courseDeleteQuestion(courseCode, questionId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a question from a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).courseGetQuestion(courseCode, questionId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
         * @param {string} courseCode unique string identifier of the course in which the answer will be located.
         * @param {string} testId unique int identifier of the test the answer will belong to.
         * @param {string} questionId unique int identifier of the question in which the answer will be added.
         * @param {QuestionIdAnswerBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async questionCreateAnswer(courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).questionCreateAnswer(courseCode, testId, questionId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get answers from a question
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {string} testId unique integer identifier of the test.
         * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async questionGetAnswer(courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).questionGetAnswer(courseCode, testId, questionId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Upload an image into a question
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} questionId unique string identifier of the parent question.
         * @param {Blob} [imageUpload] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async questionUploadImageForm(courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).questionUploadImageForm(courseCode, questionId, imageUpload, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Create a test in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeTestBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testCreate(courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testCreate(courseCode, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Create a test in a learningpath
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
         * @param {LearningpathIdTestBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testCreateInLp(courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testCreateInLp(courseCode, learningpathId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Create a question in a test
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} testId unique int identifier of the test in which the question will be added.
         * @param {TestIdQuestionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testCreateQuestion(courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testCreateQuestion(courseCode, testId, body, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Delete a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testDelete(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testDelete(courseCode, testId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testGet(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testGet(courseCode, testId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get list of tests in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testGetList(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testGetList(courseCode, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Get questions from a test
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {number} testId unique integer identifier of the test you wish to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testGetQuestions(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testGetQuestions(courseCode, testId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
        /**
         * 
         * @summary Remove a question from a test.
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} testId unique integer identifier of the parent test.
         * @param {string} questionId unique integer identifier of the parent question.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testRemoveQuestion(courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>> {
            const localVarAxiosArgs = await TestsApiAxiosParamCreator(configuration).testRemoveQuestion(courseCode, testId, questionId, options);
            return (axios: AxiosInstance = globalAxios, basePath: string = BASE_PATH) => {
                const axiosRequestArgs :AxiosRequestConfig = {...localVarAxiosArgs.options, url: basePath + localVarAxiosArgs.url};
                return axios.request(axiosRequestArgs);
            };
        },
    }
};

/**
 * TestsApi - factory interface
 * @export
 */
export const TestsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    return {
        /**
         * 
         * @summary Creates a question in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeQuestionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseCreateQuestion(courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).courseCreateQuestion(courseCode, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a question and remove it from all tests.
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseDeleteQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).courseDeleteQuestion(courseCode, questionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a question from a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} questionId unique int identifier of the test in which the question will be added.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async courseGetQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).courseGetQuestion(courseCode, questionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
         * @param {string} courseCode unique string identifier of the course in which the answer will be located.
         * @param {string} testId unique int identifier of the test the answer will belong to.
         * @param {string} questionId unique int identifier of the question in which the answer will be added.
         * @param {QuestionIdAnswerBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async questionCreateAnswer(courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).questionCreateAnswer(courseCode, testId, questionId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get answers from a question
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {string} testId unique integer identifier of the test.
         * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async questionGetAnswer(courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).questionGetAnswer(courseCode, testId, questionId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Upload an image into a question
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} questionId unique string identifier of the parent question.
         * @param {Blob} [imageUpload] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async questionUploadImageForm(courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).questionUploadImageForm(courseCode, questionId, imageUpload, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a test in a course
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {CourseCodeTestBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testCreate(courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testCreate(courseCode, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a test in a learningpath
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
         * @param {LearningpathIdTestBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testCreateInLp(courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testCreateInLp(courseCode, learningpathId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a question in a test
         * @param {string} courseCode unique string identifier of the course in which the test will be located.
         * @param {number} testId unique int identifier of the test in which the question will be added.
         * @param {TestIdQuestionBody} [body] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testCreateQuestion(courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testCreateQuestion(courseCode, testId, body, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testDelete(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testDelete(courseCode, testId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get a test from a course
         * @param {string} courseCode unique string identifier of the course in which the test is located.
         * @param {number} testId unique int identifier of the requested test.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testGet(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testGet(courseCode, testId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get list of tests in course
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testGetList(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testGetList(courseCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get questions from a test
         * @param {string} courseCode unique string identifier of the course in which the tests are located.
         * @param {number} testId unique integer identifier of the test you wish to retrieve.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testGetQuestions(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testGetQuestions(courseCode, testId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Remove a question from a test.
         * @param {string} courseCode unique string identifier of the parent course.
         * @param {number} testId unique integer identifier of the parent test.
         * @param {string} questionId unique integer identifier of the parent question.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async testRemoveQuestion(courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>> {
            return TestsApiFp(configuration).testRemoveQuestion(courseCode, testId, questionId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * TestsApi - object-oriented interface
 * @export
 * @class TestsApi
 * @extends {BaseAPI}
 */
export class TestsApi extends BaseAPI {
    /**
     * 
     * @summary Creates a question in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeQuestionBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async courseCreateQuestion(courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).courseCreateQuestion(courseCode, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete a question and remove it from all tests.
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async courseDeleteQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).courseDeleteQuestion(courseCode, questionId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get a question from a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async courseGetQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).courseGetQuestion(courseCode, questionId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
     * @param {string} courseCode unique string identifier of the course in which the answer will be located.
     * @param {string} testId unique int identifier of the test the answer will belong to.
     * @param {string} questionId unique int identifier of the question in which the answer will be added.
     * @param {QuestionIdAnswerBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async questionCreateAnswer(courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).questionCreateAnswer(courseCode, testId, questionId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get answers from a question
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {string} testId unique integer identifier of the test.
     * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async questionGetAnswer(courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).questionGetAnswer(courseCode, testId, questionId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Upload an image into a question
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} questionId unique string identifier of the parent question.
     * @param {Blob} [imageUpload] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async questionUploadImageForm(courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).questionUploadImageForm(courseCode, questionId, imageUpload, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Create a test in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeTestBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testCreate(courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testCreate(courseCode, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Create a test in a learningpath
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
     * @param {LearningpathIdTestBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testCreateInLp(courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testCreateInLp(courseCode, learningpathId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Create a question in a test
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} testId unique int identifier of the test in which the question will be added.
     * @param {TestIdQuestionBody} [body] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testCreateQuestion(courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testCreateQuestion(courseCode, testId, body, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Delete a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testDelete(courseCode: string, testId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testDelete(courseCode, testId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testGet(courseCode: string, testId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testGet(courseCode, testId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get list of tests in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testGetList(courseCode: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testGetList(courseCode, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Get questions from a test
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {number} testId unique integer identifier of the test you wish to retrieve.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testGetQuestions(courseCode: string, testId: number, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testGetQuestions(courseCode, testId, options).then((request) => request(this.axios, this.basePath));
    }
    /**
     * 
     * @summary Remove a question from a test.
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} testId unique integer identifier of the parent test.
     * @param {string} questionId unique integer identifier of the parent question.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    public async testRemoveQuestion(courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig) : Promise<AxiosResponse<void>> {
        return TestsApiFp(this.configuration).testRemoveQuestion(courseCode, testId, questionId, options).then((request) => request(this.axios, this.basePath));
    }
}
