/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CourseBody } from '../models';
import { CourseCodeDescriptionBody } from '../models';
import { CoursesCategoryBody } from '../models';
import { GlossaryGlossaryIdBody } from '../models';
import { ToolGlossaryBody } from '../models';
import { ToolIdIntroTextBody } from '../models';
/**
 * CoursesApi - axios parameter creator
 * @export
 */
export declare const CoursesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Add a category
     * @param {CoursesCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseAddCategory: (body?: CoursesCategoryBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add a course description
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {CourseCodeDescriptionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseAddDescription: (courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add a course
     * @param {CourseBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseCreate: (body?: CourseBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDelete: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteCategory: (categoryCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGet: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get backup of a course
     * @param {string} courseCode unique string identifier of the course to backup.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetBackup: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetCategories: (options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetCategory: (categoryCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of courses
     * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
     * @param {number} [howmany] Number of results we want. Optional.
     * @param {number} [visibility] the visibility of the course, or all by default. Optional.
     * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
     * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetList: (from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of resources in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetResources: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Adds a new term to the course glossary tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {ToolGlossaryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolAddGlossaryTerm: (courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Adds an introduction text to specified tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {string} toolId The id of the tool.
     * @param {ToolIdIntroTextBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolAddIntroText: (courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Deletes a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolDeleteGlossaryTerm: (courseCode: string, glossaryId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Edits a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {GlossaryGlossaryIdBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolEditGlossaryTerm: (courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of terms from course glossary
     * @param {string} courseCode unique string identifier of the course.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolGetGlossaryTerms: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * CoursesApi - functional programming interface
 * @export
 */
export declare const CoursesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Add a category
     * @param {CoursesCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseAddCategory(body?: CoursesCategoryBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Add a course description
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {CourseCodeDescriptionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseAddDescription(courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Add a course
     * @param {CourseBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseCreate(body?: CourseBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDelete(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGet(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get backup of a course
     * @param {string} courseCode unique string identifier of the course to backup.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetBackup(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetCategories(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of courses
     * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
     * @param {number} [howmany] Number of results we want. Optional.
     * @param {number} [visibility] the visibility of the course, or all by default. Optional.
     * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
     * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetList(from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of resources in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetResources(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Adds a new term to the course glossary tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {ToolGlossaryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolAddGlossaryTerm(courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Adds an introduction text to specified tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {string} toolId The id of the tool.
     * @param {ToolIdIntroTextBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolAddIntroText(courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Deletes a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolDeleteGlossaryTerm(courseCode: string, glossaryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Edits a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {GlossaryGlossaryIdBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolEditGlossaryTerm(courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of terms from course glossary
     * @param {string} courseCode unique string identifier of the course.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolGetGlossaryTerms(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
};
/**
 * CoursesApi - factory interface
 * @export
 */
export declare const CoursesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Add a category
     * @param {CoursesCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseAddCategory(body?: CoursesCategoryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add a course description
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {CourseCodeDescriptionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseAddDescription(courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add a course
     * @param {CourseBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseCreate(body?: CourseBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDelete(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGet(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get backup of a course
     * @param {string} courseCode unique string identifier of the course to backup.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetBackup(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetCategories(options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of courses
     * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
     * @param {number} [howmany] Number of results we want. Optional.
     * @param {number} [visibility] the visibility of the course, or all by default. Optional.
     * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
     * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetList(from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of resources in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetResources(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Adds a new term to the course glossary tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {ToolGlossaryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolAddGlossaryTerm(courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Adds an introduction text to specified tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {string} toolId The id of the tool.
     * @param {ToolIdIntroTextBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolAddIntroText(courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Deletes a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolDeleteGlossaryTerm(courseCode: string, glossaryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Edits a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {GlossaryGlossaryIdBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolEditGlossaryTerm(courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of terms from course glossary
     * @param {string} courseCode unique string identifier of the course.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    toolGetGlossaryTerms(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
};
/**
 * CoursesApi - object-oriented interface
 * @export
 * @class CoursesApi
 * @extends {BaseAPI}
 */
export declare class CoursesApi extends BaseAPI {
    /**
     *
     * @summary Add a category
     * @param {CoursesCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseAddCategory(body?: CoursesCategoryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add a course description
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {CourseCodeDescriptionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseAddDescription(courseCode: string, body?: CourseCodeDescriptionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add a course
     * @param {CourseBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseCreate(body?: CourseBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseDelete(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseDeleteCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get course by course code
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseGet(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get backup of a course
     * @param {string} courseCode unique string identifier of the course to backup.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseGetBackup(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseGetCategories(options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get category by category code
     * @param {string} categoryCode unique string identifier of the category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseGetCategory(categoryCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of courses
     * @param {number} [from] Offset (from the 7th &#x3D; &#x27;6&#x27;). Optional.
     * @param {number} [howmany] Number of results we want. Optional.
     * @param {number} [visibility] the visibility of the course, or all by default. Optional.
     * @param {string} [startwith] If defined, only return results for which the course *title* begins with this string. Optional.
     * @param {boolean} [alsoSearchCode] An extension option to indicate that we also want to search for course codes. Optional.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseGetList(from?: number, howmany?: number, visibility?: number, startwith?: string, alsoSearchCode?: boolean, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of resources in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    courseGetResources(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Adds a new term to the course glossary tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {ToolGlossaryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    toolAddGlossaryTerm(courseCode: string, body?: ToolGlossaryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Adds an introduction text to specified tool
     * @param {string} courseCode unique string identifier of the course.
     * @param {string} toolId The id of the tool.
     * @param {ToolIdIntroTextBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    toolAddIntroText(courseCode: string, toolId: string, body?: ToolIdIntroTextBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Deletes a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    toolDeleteGlossaryTerm(courseCode: string, glossaryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Edits a glossary term by id.
     * @param {string} courseCode unique string identifier of the course.
     * @param {number} glossaryId unique integer identifier of the glossary term.
     * @param {GlossaryGlossaryIdBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    toolEditGlossaryTerm(courseCode: string, glossaryId: number, body?: GlossaryGlossaryIdBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of terms from course glossary
     * @param {string} courseCode unique string identifier of the course.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof CoursesApi
     */
    toolGetGlossaryTerms(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
}
