/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { LearningpathIdDocumentBody } from '../models';
/**
 * DocumentsApi - axios parameter creator
 * @export
 */
export declare const DocumentsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Soft delete a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteDocument: (courseCode: string, documentId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetDocument: (courseCode: string, documentId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of documents in course
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetDocuments: (courseCode: string, path?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Upload a document into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [file]
     * @param {string} [path]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseUploadDocumentForm: (courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Upload an image into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [imageUpload]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseUploadImageForm: (courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a document in a learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdDocumentBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateDocument: (courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of documents in learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetDocuments: (courseCode: string, learningpathId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * DocumentsApi - functional programming interface
 * @export
 */
export declare const DocumentsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Soft delete a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of documents in course
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetDocuments(courseCode: string, path?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Upload a document into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [file]
     * @param {string} [path]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseUploadDocumentForm(courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Upload an image into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [imageUpload]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseUploadImageForm(courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Create a document in a learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdDocumentBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateDocument(courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of documents in learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetDocuments(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
};
/**
 * DocumentsApi - factory interface
 * @export
 */
export declare const DocumentsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Soft delete a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of documents in course
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetDocuments(courseCode: string, path?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Upload a document into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [file]
     * @param {string} [path]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseUploadDocumentForm(courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Upload an image into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [imageUpload]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseUploadImageForm(courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a document in a learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdDocumentBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateDocument(courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of documents in learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetDocuments(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
};
/**
 * DocumentsApi - object-oriented interface
 * @export
 * @class DocumentsApi
 * @extends {BaseAPI}
 */
export declare class DocumentsApi extends BaseAPI {
    /**
     *
     * @summary Soft delete a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    courseDeleteDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a document from a course.
     * @param {string} courseCode unique string identifier of the course in which the documend is located.
     * @param {string} documentId unique int identifier of the requested document.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    courseGetDocument(courseCode: string, documentId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of documents in course
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {string} [path] path to retrieve documents from (i.e. &#x27;/images/gallery&#x27;)
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    courseGetDocuments(courseCode: string, path?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Upload a document into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [file]
     * @param {string} [path]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    courseUploadDocumentForm(courseCode: string, file?: Blob, path?: string, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Upload an image into a course
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {Blob} [imageUpload]
     * @param {string} [title]
     * @param {string} [comment]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    courseUploadImageForm(courseCode: string, imageUpload?: Blob, title?: string, comment?: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a document in a learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdDocumentBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    lpCreateDocument(courseCode: string, learningpathId: number, body?: LearningpathIdDocumentBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of documents in learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path documents are located.
     * @param {number} learningpathId unique int identifier of the learning path in which the document is located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof DocumentsApi
     */
    lpGetDocuments(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
}
