/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CourseCodeLearningpathBody } from '../models';
import { LearningpathIdItemBody } from '../models';
import { LearningpathIdSectionBody } from '../models';
import { LearningpathsCategoryBody } from '../models';
import { LpItemIdAudioBody1 } from '../models';
/**
 * LearningPathsApi - axios parameter creator
 * @export
 */
export declare const LearningPathsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Create a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
     * @param {CourseCodeLearningpathBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreate: (courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a learning path category in a course
     * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
     * @param {LearningpathsCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateCategory: (courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Creates an item in a learning path from a resource
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdItemBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateItem: (courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add section to learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdSectionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateSection: (courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDelete: (courseCode: string, learningpathId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDeleteCategory: (courseCode: string, categoryId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDeleteSection: (courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get learningpath as scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {number} learningpathId unique int identifier of the learning path.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpExportScorm: (courseCode: string, learningpathId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a learning path from a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGet: (courseCode: string, learningpathId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary List learning paths categories from course
     * @param {string} courseCode the id of the course from which to list the learning path categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetCategories: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetCategory: (courseCode: string, categoryId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary List items (including sections) from course's learning path
     * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
     * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetItems: (courseCode: string, learningpathId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of learning paths from course
     * @param {string} courseCode the id of the course from which to list the learning paths
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetList: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetSection: (courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create learningpath from scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {Blob} [scormUpload]
     * @param {number} [useMaxScore]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpImportScormForm: (courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add existing audio document to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {LpItemIdAudioBody1} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpItemAddExistingAudio: (courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add audio to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {Blob} [file]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpItemUploadAudioForm: (courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * LearningPathsApi - functional programming interface
 * @export
 */
export declare const LearningPathsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Create a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
     * @param {CourseCodeLearningpathBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreate(courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Create a learning path category in a course
     * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
     * @param {LearningpathsCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateCategory(courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Creates an item in a learning path from a resource
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdItemBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateItem(courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Add section to learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdSectionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateSection(courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDelete(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDeleteCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDeleteSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get learningpath as scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {number} learningpathId unique int identifier of the learning path.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpExportScorm(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get a learning path from a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGet(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary List learning paths categories from course
     * @param {string} courseCode the id of the course from which to list the learning path categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetCategories(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary List items (including sections) from course's learning path
     * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
     * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetItems(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of learning paths from course
     * @param {string} courseCode the id of the course from which to list the learning paths
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetList(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Create learningpath from scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {Blob} [scormUpload]
     * @param {number} [useMaxScore]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpImportScormForm(courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Add existing audio document to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {LpItemIdAudioBody1} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpItemAddExistingAudio(courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Add audio to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {Blob} [file]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpItemUploadAudioForm(courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
};
/**
 * LearningPathsApi - factory interface
 * @export
 */
export declare const LearningPathsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Create a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
     * @param {CourseCodeLearningpathBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreate(courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a learning path category in a course
     * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
     * @param {LearningpathsCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateCategory(courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Creates an item in a learning path from a resource
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdItemBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateItem(courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add section to learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdSectionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpCreateSection(courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDelete(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDeleteCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpDeleteSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get learningpath as scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {number} learningpathId unique int identifier of the learning path.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpExportScorm(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a learning path from a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGet(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary List learning paths categories from course
     * @param {string} courseCode the id of the course from which to list the learning path categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetCategories(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary List items (including sections) from course's learning path
     * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
     * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetItems(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of learning paths from course
     * @param {string} courseCode the id of the course from which to list the learning paths
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetList(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpGetSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create learningpath from scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {Blob} [scormUpload]
     * @param {number} [useMaxScore]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpImportScormForm(courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add existing audio document to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {LpItemIdAudioBody1} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpItemAddExistingAudio(courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add audio to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {Blob} [file]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    lpItemUploadAudioForm(courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
};
/**
 * LearningPathsApi - object-oriented interface
 * @export
 * @class LearningPathsApi
 * @extends {BaseAPI}
 */
export declare class LearningPathsApi extends BaseAPI {
    /**
     *
     * @summary Create a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning path will be added.
     * @param {CourseCodeLearningpathBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpCreate(courseCode: string, body?: CourseCodeLearningpathBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a learning path category in a course
     * @param {string} courseCode unique int identifier of the course in which the learning path category will be added.
     * @param {LearningpathsCategoryBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpCreateCategory(courseCode: string, body?: LearningpathsCategoryBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Creates an item in a learning path from a resource
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdItemBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpCreateItem(courseCode: string, learningpathId: number, body?: LearningpathIdItemBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add section to learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section will be added.
     * @param {number} learningpathId unique int identifier of the learning path in which the section will be added.
     * @param {LearningpathIdSectionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpCreateSection(courseCode: string, learningpathId: number, body?: LearningpathIdSectionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a learning path in a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpDelete(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpDeleteCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpDeleteSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get learningpath as scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {number} learningpathId unique int identifier of the learning path.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpExportScorm(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a learning path from a course
     * @param {string} courseCode unique string identifier of the course in which the learning is located.
     * @param {number} learningpathId unique int identifier of the learning path that will be deleted.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpGet(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary List learning paths categories from course
     * @param {string} courseCode the id of the course from which to list the learning path categories
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpGetCategories(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a learning path category from a course
     * @param {string} courseCode unique string identifier of the course in which the learning path category is located.
     * @param {number} categoryId unique int identifier of the requested learning path category.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpGetCategory(courseCode: string, categoryId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary List items (including sections) from course's learning path
     * @param {string} courseCode unique string identifier of the course from which the learning path sections will be listed.
     * @param {number} learningpathId unique int identifier of the learning path from which sections will be listed.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpGetItems(courseCode: string, learningpathId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of learning paths from course
     * @param {string} courseCode the id of the course from which to list the learning paths
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpGetList(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get section from learning path
     * @param {string} courseCode unique string identifier of the course in which the learning path section is located.
     * @param {number} learningpathId unique int identifier of the learning path in which the section is located
     * @param {number} sectionId unique int identifier of the requested section.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpGetSection(courseCode: string, learningpathId: number, sectionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create learningpath from scorm package
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {Blob} [scormUpload]
     * @param {number} [useMaxScore]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpImportScormForm(courseCode: string, scormUpload?: Blob, useMaxScore?: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add existing audio document to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {LpItemIdAudioBody1} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpItemAddExistingAudio(courseCode: string, learningpathId: string, lpItemId: string, body?: LpItemIdAudioBody1, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add audio to learning path item
     * @param {string} courseCode unique string identifier of the course in which the learning path is located.
     * @param {string} learningpathId unique string identifier of the learning path.
     * @param {string} lpItemId unique string identifier of the learning path item.
     * @param {Blob} [file]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LearningPathsApi
     */
    lpItemUploadAudioForm(courseCode: string, learningpathId: string, lpItemId: string, file?: Blob, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
}
