/**
 * CourseWay Chamilo API
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 0.1.1
 *
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
import { AxiosResponse, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CourseCodeQuestionBody } from '../models';
import { CourseCodeTestBody } from '../models';
import { LearningpathIdTestBody } from '../models';
import { QuestionIdAnswerBody } from '../models';
import { TestIdQuestionBody } from '../models';
/**
 * TestsApi - axios parameter creator
 * @export
 */
export declare const TestsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Creates a question in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseCreateQuestion: (courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete a question and remove it from all tests.
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteQuestion: (courseCode: string, questionId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a question from a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetQuestion: (courseCode: string, questionId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
     * @param {string} courseCode unique string identifier of the course in which the answer will be located.
     * @param {string} testId unique int identifier of the test the answer will belong to.
     * @param {string} questionId unique int identifier of the question in which the answer will be added.
     * @param {QuestionIdAnswerBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionCreateAnswer: (courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get answers from a question
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {string} testId unique integer identifier of the test.
     * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionGetAnswer: (courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Upload an image into a question
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} questionId unique string identifier of the parent question.
     * @param {Blob} [imageUpload]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionUploadImageForm: (courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a test in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreate: (courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a test in a learningpath
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
     * @param {LearningpathIdTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreateInLp: (courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a question in a test
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} testId unique int identifier of the test in which the question will be added.
     * @param {TestIdQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreateQuestion: (courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testDelete: (courseCode: string, testId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGet: (courseCode: string, testId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get list of tests in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGetList: (courseCode: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get questions from a test
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {number} testId unique integer identifier of the test you wish to retrieve.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGetQuestions: (courseCode: string, testId: number, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Remove a question from a test.
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} testId unique integer identifier of the parent test.
     * @param {string} questionId unique integer identifier of the parent question.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testRemoveQuestion: (courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * TestsApi - functional programming interface
 * @export
 */
export declare const TestsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Creates a question in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseCreateQuestion(courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete a question and remove it from all tests.
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get a question from a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
     * @param {string} courseCode unique string identifier of the course in which the answer will be located.
     * @param {string} testId unique int identifier of the test the answer will belong to.
     * @param {string} questionId unique int identifier of the question in which the answer will be added.
     * @param {QuestionIdAnswerBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionCreateAnswer(courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get answers from a question
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {string} testId unique integer identifier of the test.
     * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionGetAnswer(courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Upload an image into a question
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} questionId unique string identifier of the parent question.
     * @param {Blob} [imageUpload]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionUploadImageForm(courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Create a test in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreate(courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Create a test in a learningpath
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
     * @param {LearningpathIdTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreateInLp(courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Create a question in a test
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} testId unique int identifier of the test in which the question will be added.
     * @param {TestIdQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreateQuestion(courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Delete a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testDelete(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGet(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get list of tests in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGetList(courseCode: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Get questions from a test
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {number} testId unique integer identifier of the test you wish to retrieve.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGetQuestions(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
    /**
     *
     * @summary Remove a question from a test.
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} testId unique integer identifier of the parent test.
     * @param {string} questionId unique integer identifier of the parent question.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testRemoveQuestion(courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => Promise<AxiosResponse<void>>>;
};
/**
 * TestsApi - factory interface
 * @export
 */
export declare const TestsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Creates a question in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseCreateQuestion(courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a question and remove it from all tests.
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseDeleteQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a question from a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    courseGetQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
     * @param {string} courseCode unique string identifier of the course in which the answer will be located.
     * @param {string} testId unique int identifier of the test the answer will belong to.
     * @param {string} questionId unique int identifier of the question in which the answer will be added.
     * @param {QuestionIdAnswerBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionCreateAnswer(courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get answers from a question
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {string} testId unique integer identifier of the test.
     * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionGetAnswer(courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Upload an image into a question
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} questionId unique string identifier of the parent question.
     * @param {Blob} [imageUpload]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    questionUploadImageForm(courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a test in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreate(courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a test in a learningpath
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
     * @param {LearningpathIdTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreateInLp(courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a question in a test
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} testId unique int identifier of the test in which the question will be added.
     * @param {TestIdQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testCreateQuestion(courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testDelete(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGet(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of tests in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGetList(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get questions from a test
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {number} testId unique integer identifier of the test you wish to retrieve.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testGetQuestions(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Remove a question from a test.
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} testId unique integer identifier of the parent test.
     * @param {string} questionId unique integer identifier of the parent question.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    testRemoveQuestion(courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
};
/**
 * TestsApi - object-oriented interface
 * @export
 * @class TestsApi
 * @extends {BaseAPI}
 */
export declare class TestsApi extends BaseAPI {
    /**
     *
     * @summary Creates a question in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    courseCreateQuestion(courseCode: string, body?: CourseCodeQuestionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a question and remove it from all tests.
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    courseDeleteQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a question from a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} questionId unique int identifier of the test in which the question will be added.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    courseGetQuestion(courseCode: string, questionId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Add an answer to a question. _TODO: Add suport for 'Scenario' question types (https://docs.chamilo.org/teacher-guide/interactivity_tests/creating_a_new_test)_
     * @param {string} courseCode unique string identifier of the course in which the answer will be located.
     * @param {string} testId unique int identifier of the test the answer will belong to.
     * @param {string} questionId unique int identifier of the question in which the answer will be added.
     * @param {QuestionIdAnswerBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    questionCreateAnswer(courseCode: string, testId: string, questionId: string, body?: QuestionIdAnswerBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get answers from a question
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {string} testId unique integer identifier of the test.
     * @param {string} questionId unique integer identifier of the question you wish to retrieve answers from.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    questionGetAnswer(courseCode: string, testId: string, questionId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Upload an image into a question
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} questionId unique string identifier of the parent question.
     * @param {Blob} [imageUpload]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    questionUploadImageForm(courseCode: string, questionId: number, imageUpload?: Blob, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a test in a course
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {CourseCodeTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testCreate(courseCode: string, body?: CourseCodeTestBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a test in a learningpath
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} learningpathId unique integer identifier of the learningpath in which the test will be located.
     * @param {LearningpathIdTestBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testCreateInLp(courseCode: string, learningpathId: number, body?: LearningpathIdTestBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Create a question in a test
     * @param {string} courseCode unique string identifier of the course in which the test will be located.
     * @param {number} testId unique int identifier of the test in which the question will be added.
     * @param {TestIdQuestionBody} [body]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testCreateQuestion(courseCode: string, testId: number, body?: TestIdQuestionBody, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Delete a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testDelete(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get a test from a course
     * @param {string} courseCode unique string identifier of the course in which the test is located.
     * @param {number} testId unique int identifier of the requested test.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testGet(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get list of tests in course
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testGetList(courseCode: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Get questions from a test
     * @param {string} courseCode unique string identifier of the course in which the tests are located.
     * @param {number} testId unique integer identifier of the test you wish to retrieve.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testGetQuestions(courseCode: string, testId: number, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
    /**
     *
     * @summary Remove a question from a test.
     * @param {string} courseCode unique string identifier of the parent course.
     * @param {number} testId unique integer identifier of the parent test.
     * @param {string} questionId unique integer identifier of the parent question.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof TestsApi
     */
    testRemoveQuestion(courseCode: string, testId: number, questionId: string, options?: AxiosRequestConfig): Promise<AxiosResponse<void>>;
}
